from rest_framework import permissions
from core.custom_annotations import in_groups

from core.models import Student, Submission, Feedback


class StudentRequestOwnData(permissions.BasePermission):
    def has_object_permission(self, request, view, obj):
        if in_groups(request.user, ['Students']):
            student = request.user.student
            if isinstance(obj, Student):
                return student == obj
            elif isinstance(obj, Submission):
                return student == obj.student
            elif isinstance(obj, Feedback):
                return student == obj.of_submission.student

        return False
