from django.contrib.auth.models import User

from rest_framework import serializers
from core.models import Student, Submission, Feedback


class FeedbackSerializer(serializers.ModelSerializer):
    class Meta:
        model = Feedback
        fields = ('text', 'score')


class SubmissionSerializer(serializers.ModelSerializer):
    feedback = FeedbackSerializer()

    class Meta:
        model = Submission
        fields = ('seen_by_student', 'text', 'type', 'student', 'feedback')


class StudentSerializer(serializers.ModelSerializer):
    user = serializers.ReadOnlyField(source='user.username')
    submissions = SubmissionSerializer(many=True)

    class Meta:
        model = Student
        fields = ('name', 'user', 'exam', 'submissions')
