
from core.models import Student, Submission, Feedback
from core.serializers import SubmissionSerializer, StudentSerializer, FeedbackSerializer
from rest_framework.generics import RetrieveAPIView


class StudentApiView(RetrieveAPIView):
    def get_object(self):
        return self.request.user.student
    serializer_class = StudentSerializer


class SubmissionApiView(RetrieveAPIView):
    def get_object(self):
        return self.request.user.student.submissions
    serializer_class = SubmissionSerializer


class FeedbackApiView(RetrieveAPIView):
    def get_queryset(self):
        return [submission.feedback for submission in self.request.user.submissions]
    serializer_class = FeedbackSerializer


class StudentPageView(RetrieveAPIView):
    queryset = Student.objects.all()


